-- name: [CS] Klonoa
-- description: Custom model of klonoa\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

-- THIS MODEL AND CHARACTER MOD WAS CREATED BY SEYMOUR AND IS NOT PERMITTED FOR RE-USE OR RE-UPLOADING.

local E_KLONOA_MODEL = smlua_model_util_get_id("klonoa_geo")

local TEX_CUSTOM_ICON = get_texture_info("klonoa-icon")

local TEXT_MOD_NAME = "Klonoa"

local VOICETABLE_CHAR = {
    [CHAR_SOUND_YAH_WAH_HOO]            = 'hup.ogg',        -- JUMP 1
    [CHAR_SOUND_HOOHOO]                 = {'pah.ogg','meh.ogg'},          -- JUMP 2
    [CHAR_SOUND_YAHOO]                  = 'wahoo.ogg',           -- JUMP 3
    [CHAR_SOUND_UH]                     = nil,            -- 
    [CHAR_SOUND_HRMM]                   = nil,
    [CHAR_SOUND_WAH2]                   = 'throw.ogg',
    [CHAR_SOUND_WHOA]                   = 'nyu.ogg',
    [CHAR_SOUND_EEUH]                   = {'struggle_grab.ogg','struggle_grab_ngah.ogg'},
    [CHAR_SOUND_ATTACKED]               = 'damage.ogg',
    [CHAR_SOUND_OOOF]                   = 'ledgebump.ogg',
    [CHAR_SOUND_OOOF2]                  = 'wah.ogg',            -- this plays when you respawn outside a level
    [CHAR_SOUND_HERE_WE_GO]             = 'rupurudu.ogg',
    [CHAR_SOUND_YAWNING]                = 'yawning.ogg',
    [CHAR_SOUND_SNORING1]               = nil,
    [CHAR_SOUND_SNORING2]               = 'exhale.ogg',
    [CHAR_SOUND_SNORING3]               = nil,
    [CHAR_SOUND_WAAAOOOW]               = {'falling.ogg','scream.ogg'},
    [CHAR_SOUND_HAHA]                   = {'rupurudu.ogg','rupurudu2.ogg','ra du.ogg'},
    [CHAR_SOUND_HAHA_2]                 = {'wahoo.ogg','wahoo2.ogg','wahoo3.ogg'},
    [CHAR_SOUND_UH2]                    = 'wallbump.ogg',
    [CHAR_SOUND_UH2_2]                  = 'wallbump.ogg',
    [CHAR_SOUND_ON_FIRE]                = 'onfire.ogg',
    [CHAR_SOUND_DYING]                  = 'dying.ogg',
    [CHAR_SOUND_PANTING_COLD]           = 'exhale.ogg',
    [CHAR_SOUND_PANTING]                = 'panting.ogg',
    [CHAR_SOUND_COUGHING1]              = 'cough.ogg',
    [CHAR_SOUND_COUGHING2]              = 'cough.ogg',
    [CHAR_SOUND_COUGHING3]              = 'cough.ogg',
    [CHAR_SOUND_PUNCH_YAH]              = 'du.ogg',
    [CHAR_SOUND_PUNCH_WAH]              = 'rup.ogg',
    [CHAR_SOUND_PUNCH_HOO]              = 'attack3.ogg',
    [CHAR_SOUND_MAMA_MIA]               = 'exhale.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH]       = 'pah.ogg',
    [CHAR_SOUND_DROWNING]               = 'drowning.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE]      = {'wahoo.ogg','wahoo2.ogg','wahoo3.ogg'},
    [CHAR_SOUND_DOH]                    = 'ledgebump.ogg',
    --[CHAR_SOUND_GAME_OVER]            = '.ogg',
    [CHAR_SOUND_HELLO]                  = 'wahoo.ogg',
    [CHAR_SOUND_PRESS_START_TO_PLAY]    = 'letsago.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE]           = 'spinning.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER]        = 'throw.ogg',
    [CHAR_SOUND_IMA_TIRED]              = nil,
    [CHAR_SOUND_LETS_A_GO]              = 'letsago.ogg',
    [CHAR_SOUND_OKEY_DOKEY]             = 'rupurudu.ogg',
    [CHAR_SOUND_MAX]                    = nil,
}

local KLONOA_PALETTE = {
    [SHIRT] = {r=0xb5, g=0x1d, b= 0x08}, -- b51d08
    [SHOES] = {r=0xf7, g=0xe7, b= 0xb0}, -- f7e7b0
     [HAIR] = {r=0x15, g=0x15, b= 0x1b}, -- 15151b
      [CAP] = {r=0x20, g=0x59, b= 0xce}, -- 2059ce
    [PANTS] = {r=0xb5, g=0x1d, b= 0x08}, -- b51d08
   [GLOVES] = {r=0xff, g=0xd0, b= 0x2e}, -- ffd02e
     [SKIN] = {r=0xff, g=0xff, b= 0xff}, -- ffffff
}


local CAPTABLE_CHAR = {
    normal      = smlua_model_util_get_id("klonoa_cap_normal_geo"),
    wing        = smlua_model_util_get_id("klonoa_cap_wing_geo"),
    metal       = smlua_model_util_get_id("klonoa_cap_metal_geo"),
    metalWing   = smlua_model_util_get_id("klonoa_cap_wing_geo"),
}

if _G.charSelectExists and SM64COOPDX_VERSION then
    CT_CHAR = _G.charSelect.character_add("Klonoa", {"The dream traveler",}, "seymour schlong", "0791d8", E_KLONOA_MODEL, CT_LUIGI, TEX_CUSTOM_ICON)

    -- code borrowed from brian mod.
    local curVers = _G.charSelect.version_get();
	if not tonumber(curVers) then -- if this cannot be simplified to a number, there's other strings in this
		curVers = string.gsub(curVers, "[%a%s_()!?:,@#-]+", ""); -- removing all letters, spaces, and the chars in the [set]
		
		curVers = curVers:gsub("%.", "X", 1):gsub("%.", ""):gsub("X", "."); -- removes all instances except the first decimal point
	end
	curVers = tonumber(curVers);

    if curVers >= 1.8 then
		_G.charSelect.character_add_palette_preset(E_KLONOA_MODEL, KLONOA_PALETTE);
	end

    _G.charSelect.character_add_caps(E_KLONOA_MODEL, CAPTABLE_CHAR)
    _G.charSelect.character_add_voice(E_KLONOA_MODEL, VOICETABLE_CHAR)
    
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_CHAR then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end


-- HUEPOW PET

if not _G.wpets then return end

local E_MODEL_HUEPOW = smlua_model_util_get_id('huepow_geo')

local ID_HUEPOW = _G.wpets.add_pet({
	name = "Huepow", credit = "seymour schlong",
	description = "Always with you, even when times are tough!",
	modelID = E_MODEL_HUEPOW,
	scale = 1.0, yOffset = 0, flying = true
})

_G.wpets.set_pet_anims_wing(ID_HUEPOW)

_G.wpets.set_pet_sounds(ID_HUEPOW, {
	spawn = {'huepow_spawn.ogg','huepow_huepi.ogg','huepow_huepopi.ogg'},
	happy = {'huepow_happy.ogg','huepow_spawn.ogg','huepow_papi.ogg','huepow_pipa.ogg'},
	vanish = nil,
	step = nil
})

-- required hook for samples (audio files from the mod's 'sound' folder)
-- if no pets in your pack use samples, you can remove this section.
hook_event(HOOK_UPDATE, function ()
	-- copy the following line for each pet in the pack that uses samples.
    _G.wpets.process_pet_samples(ID_HUEPOW)
end)